#include <bits/stdc++.h>
using namespace std;
#define ll long long


struct node {
    ll v;
    deque<ll> l;
    deque<ll> ans_l;
    deque<ll> ind_l;
    deque<ll> h;
    deque<ll> ind;
};

vector<ll> pref;


vector<node> p;

ll root(ll v) {
    if (p[v].v == v) {
        return v;
    }
    p[v].v = root(p[v].v);
    return p[v].v;
}

void merge(ll a,ll b) {
    a = root(a);
    b = root(b);
    if (a == b) {
        return;
    }
    for (ll i = 0; i < p[b].h.size(); i++) {
        p[a].h.push_back(p[b].h[i]);
        p[a].ind.push_back(p[b].ind[i]);
    }
    for (ll i = 0; i < p[b].h.size(); i++) {
        while (p[a].l.size() > 1 && p[a].l.front() < p[b].h[i]) {
            p[a].l.pop_front();
            p[a].ans_l.pop_front();
            p[a].ind_l.pop_front();
        }
        ll ans = p[a].ans_l.front();
        ans += -abs(pref[p[a].ind_l.front() + 1] - pref[p[b].ind[i]]) + (
            (abs(p[a].ind_l.front() - p[b].ind[i]) - 1) * min(p[b].h[i], p[a].l.front()));
        if (p[a].l.front() < p[b].h[i]) {
            p[a].l.pop_front();
            p[a].ans_l.pop_front();
            p[a].ind_l.pop_front();
        }
        p[a].ans_l.push_front(ans);
        p[a].l.push_front(p[b].h[i]);
        p[a].ind_l.push_front(p[b].ind[i]);
    }
    p[b].v = a;
}

//
// ll v1 = p[a].l;
// ll v2 = p[b].r;
// ll sum_v1 = p[a].sum_l;
// ll sum_v2 = p[b].sum_r;
// if (p[a].mx != p[b].mx) {
//     if (p[a].mx > p[b].mx) {
//         v2 = p[a].r;
//     } else {
//         v1 = p[b].l;
//     }
// }


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    p.resize(n);
    pref.resize(n + 1);
    vector<ll> h(n), k(n);
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
        p[i].v = i;
        p[i].l.push_back(h[i]);
        p[i].ind_l.push_back(i);
        p[i].ans_l.push_back(0);
        p[i].ind.push_back(i);
        p[i].h.push_back(h[i]);
    }
    for (ll i = 0; i < n - 1; i++) {
        cin >> k[i];
        ll cnt = 0;
        ll last = -1;
        for (ll j = 0; j < n; j++) {
            if (last != root(p[j].v)) {
                last = root(p[j].v);
                cnt++;
                if (cnt - 1 == k[i]) {
                    merge(j - 1, j);
                    break;
                }
            }
        }
        ll v = root(last);
        cout << p[v].ans_l.front() << endl;
    }
}

// 8
// 9 1 8 1 5 2 3 6
// 3 3 1 3 3 2 1

// 3
// 10 1 10
// 1 1
