#include <bits/stdc++.h>
using namespace std;

#define ll int
ll n, m, k;
map<ll,ll> mp;
vector<ll> used;
vector<ll> q;
vector<vector<ll> > g;

ll cnt = 0;
ll ans = 0;

void dfs(ll v) {
    used[v] = 1;
    q.push_back(v);
    cnt += mp[v];
    for (ll i = 0; i < g[v].size(); i++) {
        ll to = g[v][i];
        if (used[to] == 0) {
            dfs(to);
        } else {
            if (to == 0) {
                if (q.size() == n + n + m + m - 4 && cnt == k && used[n * m - 1] == 1) {
                    ans++;
                }
            }
        }
    }
    q.pop_back();
    cnt -= mp[v];
    used[v] = 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> k;
    g.resize(n * m);
    used.resize(n * m);
    for (ll i = 0; i < k; i++) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        mp[a * m + b] = 1;
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            ll a=i;
            ll b=j;
            if (a != 0) {
                g[a * m + b].push_back((a - 1) * m + b);
            }
            if (a != n - 1) {
                g[a * m + b].push_back((a + 1) * m + b);
            }
            if (b != 0) {
                g[a * m + b].push_back(a * m + b - 1);
            }
            if (b != m - 1) {
                g[a * m + b].push_back(a * m + b + 1);
            }
        }
    }
    dfs(0);
    cout << ans;
}
